Skip to main content
`Ctrl`+`K`

# DMDAVecGetArrayWrite

Returns a multiple dimension array that shares data with the underlying vector and is indexed using the global or local dimensions of a `DMDA`.

## Synopsis

    #include "petscdmda.h"
    PetscErrorCode DMDAVecGetArrayWrite(DM da, Vec vec, void *array)

Logically Collective

## Input Parameters

- da - the `DMDA`

- vec - a vector the same size as one obtained with `DMCreateGlobalVector()` or `DMCreateLocalVector()`

## Output Parameter

- array - the array

## Notes

Call `DMDAVecRestoreArray()` once you have finished accessing the vector entries.

In C, the indexing is “backwards” from what expects: array[k][j][i] NOT array[i][j][k]!

if `vec` is a local vector (obtained with `DMCreateLocalVector()` etc) then the ghost point locations are accessible. If it is a global vector then the ghost points are not accessible. Of course with the local vector you will have had to do the appropriate `DMGlobalToLocalBegin()` and `DMGlobalToLocalEnd()` to have correct values in the ghost locations.

The accessible indices are `array[zs:zs+zm-1][ys:ys+ym-1][xs:xs+xm-1]` where the values are obtained from `DMDAGetCorners()` for a global vector or `DMDAGetGhostCorners()` for a local vector.

## Fortran Notes

Use `DMDAVecGetArrayWrite()` and pass for the array type PetscScalar,pointer :: array(:,…,:) of the appropriate dimension. For a `DMDA` created with a dof of 1 use the dimension of the `DMDA`, for a `DMDA` created with a dof greater than 1 use one more than the dimension of the `DMDA`.

The order of the indices is `array(xs:xs+xm-1,ys:ys+ym-1,zs:zs+zm-1)` (when dof is 1) otherwise `array(0:dof-1,xs:xs+xm-1,ys:ys+ym-1,zs:zs+zm-1)` where the values are obtained from `DMDAGetCorners()` for a global vector or `DMDAGetGhostCorners()` for a local vector.

## Developer Note

This has code duplication with `DMDAVecGetArray()` and `DMDAVecGetArrayRead()`

## See Also

DMDA - Creating vectors for structured grids, DMDA - Setting vector values, `DM`, `DMDA`, `DMDAGetGhostCorners()`, `DMDAGetCorners()`, `VecGetArray()`, `VecRestoreArray()`, `DMDAVecRestoreArrayWrite()`, `DMDAVecRestoreArrayDOF()`, `DMDAVecGetArrayDOF()`, `DMDAVecGetArray()`, `DMDAVecRestoreArray()`, `DMDAVecGetArrayRead()`, `DMDAVecRestoreArrayRead()`

## Level

intermediate

## Location

src/dm/impls/da/dagetarray.c

## Examples

src/snes/tutorials/ex19.c
src/dm/tutorials/ex2.c

Index of all DMDA routines
Table of Contents for all manual pages
Index of all manual pages